CREATE OR REPLACE PROCEDURE BUSCA_CUSTO_RECEITA(P_IDOPCAO IN VARCHAR2,
                                                P_CDFILIAL IN VARCHAR2,
                                                P_NRTIPOCUSTO  IN NUMBER,
                                                P_CDARVINI IN VARCHAR2,
                                                P_CDARVFIN IN VARCHAR2,
                                                P_SEQTRABPROCF OUT VARCHAR2)
IS
   V_CUSTOATUAL FLOAT;
   V_VRHISCUSTOPROD HISTCUSTOPROD.VRHISCUSTOPROD%TYPE;
   V_VRPERCDIFECUS FLOAT;
   V_VRCALCCUSTO FLOAT;
   V_VRPERDIFCUSPREC PARAMPEDIDO.VRPERDIFCUSPREC%TYPE;
   V_STNUMERO NOVOCODIGO.NRSEQUENCIAL%TYPE;
   V_VRDIVISOR FLOAT;
BEGIN

   V_VRPERCDIFECUS := 0;
   V_CUSTOATUAL :=0;

   BEGIN
      SELECT NVL(VRPERDIFCUSPREC,0)
        INTO V_VRPERDIFCUSPREC
        FROM PARAMPEDIDO
        WHERE CDFILIAL = P_CDFILIAL;
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_VRPERDIFCUSPREC := 0;
   END;


   /* BUSCA SEQUENCIAL DA TABELA DE TRABALHO */
    NOVO_CODIGO_SC('TRABDIFCUSTPROD'||P_CDFILIAL, V_STNUMERO, 1);
    V_STNUMERO  :=  SUBSTR( V_STNUMERO,11,10);

   
   IF P_IDOPCAO IN( 'I','P') THEN 
   
      /* BUSCA PRODUTOS ACABADOS */
      FOR C_PRODACAB IN (SELECT CDPRODUTO, CDPROCFABRIC, DTVALPROFABR
                           FROM PROCFABRICA
                          WHERE CDFILIAL = P_CDFILIAL
                            AND IDPROFABPADR = 'S')
      LOOP
         IF P_IDOPCAO = 'I' THEN
            V_CUSTOATUAL := 0;
            V_VRCALCCUSTO := 0;
      
            SELECT ROUND(SUM(ROUND(CUSTO_PRODUTO(P_CDFILIAL, CDPRODINSUMO, P_NRTIPOCUSTO, SYSDATE, SYSDATE),2)*QTINSUMETAPA),2)
              INTO V_CUSTOATUAL
              FROM INSUMETAPA
              WHERE CDFILIAL  =  P_CDFILIAL
                AND CDPRODUTO =  C_PRODACAB.CDPRODUTO
                AND CDPROCFABRIC = C_PRODACAB.CDPROCFABRIC;
      
            /* BUSCA O CUSTO ANTERIOR  */
            BEGIN
               SELECT NVL(VRHISCUSTOPROD,1) 
                 INTO V_VRHISCUSTOPROD
                 FROM HISTCUSTOPROD
                WHERE CDFILIALHIST = P_CDFILIAL
                  AND CDPRODUTOHIST = C_PRODACAB.CDPRODUTO;
            EXCEPTION
               WHEN NO_DATA_FOUND THEN
                  V_VRHISCUSTOPROD := 0;
            END;
            
            V_VRDIVISOR := V_VRHISCUSTOPROD;
            IF ((V_VRHISCUSTOPROD = 0) OR (V_VRHISCUSTOPROD IS NULL)) THEN
               V_VRDIVISOR := 1;
            END IF;
            IF V_CUSTOATUAL > 0 THEN
               /* TESTA A DIFERENA*/
               V_VRCALCCUSTO :=  ABS( NVL(V_VRHISCUSTOPROD,0) - V_CUSTOATUAL);
      
               IF(V_VRCALCCUSTO * 100 / NVL(V_VRDIVISOR,1)) >= (V_VRPERDIFCUSPREC/100) THEN
                  INSERT INTO TRABDIFCUSTPROD( NRSEQDIFCUST, CDFILIALTRAB, CDPRODUTOTRAB, VRCUSTANTPROD, VRCUSTATUPROD, VRPERDIFCUSTPRO)
                                        VALUES( V_STNUMERO, P_CDFILIAL, C_PRODACAB.CDPRODUTO, V_VRHISCUSTOPROD, V_CUSTOATUAL, (V_VRCALCCUSTO * 100 / NVL(V_VRDIVISOR,1)));
               END IF;
            END IF;
      
         ELSE
            V_CUSTOATUAL := 0;
            V_VRCALCCUSTO := 0;
      
            /* BUSCA O CUSTO ANTERIOR */
            BEGIN
               SELECT NVL(VRHISCUSTOPROD,1)
                 INTO V_VRHISCUSTOPROD
                 FROM HISTCUSTOPROD
                WHERE
                  CDFILIALHIST = P_CDFILIAL AND
                  CDPRODUTOHIST = C_PRODACAB.CDPRODUTO;
      
            EXCEPTION
               WHEN NO_DATA_FOUND THEN
                  V_VRHISCUSTOPROD := 0;
            END;
            
            V_VRDIVISOR := V_VRHISCUSTOPROD;
            IF ((V_VRHISCUSTOPROD = 0) OR (V_VRHISCUSTOPROD IS NULL)) THEN
               V_VRDIVISOR := 1;
            END IF;
            V_CUSTOATUAL := ROUND(CUSTO_PRODUTO( P_CDFILIAL, C_PRODACAB.CDPRODUTO, P_NRTIPOCUSTO, SYSDATE, SYSDATE),2);
      
            IF V_CUSTOATUAL >0 THEN
               /* TESTA A DIFERENA*/
               IF NVL(V_VRHISCUSTOPROD,0)> 0 THEN
                  V_VRCALCCUSTO :=  ABS( NVL(V_VRHISCUSTOPROD,0) - V_CUSTOATUAL);
                  IF(V_VRCALCCUSTO * 100 / NVL(V_VRDIVISOR,1)) >= (V_VRPERDIFCUSPREC/100) THEN
                     INSERT INTO TRABDIFCUSTPROD( NRSEQDIFCUST, CDFILIALTRAB, CDPRODUTOTRAB, VRCUSTANTPROD, VRCUSTATUPROD, VRPERDIFCUSTPRO)
                                           VALUES( V_STNUMERO, P_CDFILIAL, C_PRODACAB.CDPRODUTO, V_VRHISCUSTOPROD, V_CUSTOATUAL, (V_VRCALCCUSTO * 100 / NVL(V_VRDIVISOR,1)) );
                  END IF;
               ELSE
                  INSERT INTO TRABDIFCUSTPROD( NRSEQDIFCUST, CDFILIALTRAB, CDPRODUTOTRAB, VRCUSTANTPROD, VRCUSTATUPROD, VRPERDIFCUSTPRO)
                                           VALUES( V_STNUMERO, P_CDFILIAL, C_PRODACAB.CDPRODUTO, V_VRHISCUSTOPROD, V_CUSTOATUAL, (V_VRCALCCUSTO * 100 / NVL(V_VRDIVISOR,1)));
               END IF;
            END IF;
         END IF;
      END LOOP;
   ELSE
      FOR C_PRODREVENDA IN (SELECT PR.CDPRODUTO, PR.CDPRODESTO, PR.VRFATOCONV
                              FROM PRODUTO PR                               
                             WHERE CDPRODUTO NOT IN (SELECT CDPRODUTO 
                                                       FROM PROCFABRICA 
                                                      WHERE CDFILIAL = P_CDFILIAL 
                                                        AND IDPROFABPADR = 'S')
                               AND PR.CDARVPROD BETWEEN P_CDARVINI AND P_CDARVFIN||'ZZZZZZZZZZZZZ'
                               AND PR.CDNVPRODUTO = (SELECT (LENGTH(CDPICTPROD) - LENGTH(REPLACE(CDPICTPROD, '.')))+1 
                                                       FROM PARAMGERAL)
                             ORDER BY PR.CDARVPROD) LOOP
         
            V_CUSTOATUAL := 0;
            V_VRCALCCUSTO := 0;
      
            /* BUSCA O CUSTO ANTERIOR */
            BEGIN
               SELECT NVL(VRHISCUSTOPROD,1)
                 INTO V_VRHISCUSTOPROD
                 FROM HISTCUSTOPROD
                WHERE
                  CDFILIALHIST = P_CDFILIAL AND
                  CDPRODUTOHIST = C_PRODREVENDA.CDPRODUTO;
      
            EXCEPTION
               WHEN NO_DATA_FOUND THEN
                  V_VRHISCUSTOPROD := 0;
            END;
            
            V_VRDIVISOR := V_VRHISCUSTOPROD;
            IF ((V_VRHISCUSTOPROD = 0) OR (V_VRHISCUSTOPROD IS NULL)) THEN
               V_VRDIVISOR := 1;
            END IF;
            V_CUSTOATUAL := ROUND(CUSTO_PRODUTO( P_CDFILIAL, C_PRODREVENDA.CDPRODESTO, P_NRTIPOCUSTO, SYSDATE, SYSDATE),2) * C_PRODREVENDA.VRFATOCONV;
      
            IF V_CUSTOATUAL >0 THEN
               /* TESTA A DIFERENA*/
               IF NVL(V_VRHISCUSTOPROD,0)> 0 THEN
                  V_VRCALCCUSTO :=  ABS( NVL(V_VRHISCUSTOPROD,0) - V_CUSTOATUAL);
                  IF(V_VRCALCCUSTO * 100 / NVL(V_VRDIVISOR,1)) >= (V_VRPERDIFCUSPREC/100) THEN
                     INSERT INTO TRABDIFCUSTPROD( NRSEQDIFCUST, CDFILIALTRAB, CDPRODUTOTRAB, VRCUSTANTPROD, VRCUSTATUPROD, VRPERDIFCUSTPRO)
                                           VALUES( V_STNUMERO, P_CDFILIAL, C_PRODREVENDA.CDPRODUTO, V_VRHISCUSTOPROD, V_CUSTOATUAL, (V_VRCALCCUSTO * 100 / NVL(V_VRDIVISOR,1)) );
                  END IF;
               ELSE
                  INSERT INTO TRABDIFCUSTPROD( NRSEQDIFCUST, CDFILIALTRAB, CDPRODUTOTRAB, VRCUSTANTPROD, VRCUSTATUPROD, VRPERDIFCUSTPRO)
                                           VALUES( V_STNUMERO, P_CDFILIAL, C_PRODREVENDA.CDPRODUTO, V_VRHISCUSTOPROD, V_CUSTOATUAL, (V_VRCALCCUSTO * 100 / NVL(V_VRDIVISOR,1)));
               END IF;
            END IF;               
      END LOOP;
   END IF;
   P_SEQTRABPROCF := V_STNUMERO;
 
END;

/